/*
        Copyright (c) 2006 Russ Cox.

Permission to use, copy, modify, and distribute this software for any
purpose without fee is hereby granted, provided that this entire notice
is included in all copies of any software which is or includes a copy
or modification of this software and in all copies of the supporting
documentation for such software.

THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
WARRANTY.  IN PARTICULAR, THE AUTHOR MAKES NO REPRESENTATION OR WARRANTY
OF ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
FITNESS FOR ANY PARTICULAR PURPOSE.
*/

#include <errno.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "utf.h"
#include "fmt.h"
#include "fuse_kernel.h"

#define uchar	_uchar
#define ushort	_ushort
#define uint	_uint
#define ulong	_ulong
typedef unsigned char		uchar;
typedef unsigned short		ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;
typedef long long	vlong;
typedef unsigned long long	uvlong;

#define	nil	((void*)0)
#define	nelem(x)	(sizeof (x)/sizeof (x)[0])

int		errstr(char *err, uint n);
void		rerrstr(char *err, uint n);
void		sysfatal(char *fmt, ...);
void		werrstr(char *fmt, ...);

/* Somehow the FUSE guys forgot to define this one! */
struct fuse_create_out {
	struct fuse_entry_out e;
	struct fuse_open_out o;
};

typedef struct FuseMsg FuseMsg;
struct FuseMsg
{
	FuseMsg *next;
	uchar *buf;
	int nbuf;
	struct fuse_in_header *hdr;	/* = buf */
	void *tx;	/* = hdr+1 */
};

extern int debug;

extern int fusefd;
extern int fuseeof;
extern int fusebufsize;
extern int fusemaxwrite;
extern FuseMsg *fusemsglist;
extern char *fusemtpt;

void		freefusemsg(FuseMsg *m);
int		fusefmt(Fmt*);
void		initfuse(char *mtpt);
void	waitfuse(void);
FuseMsg*	readfusemsg(void);
void		replyfuse(FuseMsg *m, void *arg, int narg);
void		replyfuseerrno(FuseMsg *m, int e);
void		replyfuseerrstr(FuseMsg*);

void*		emalloc(uint n);
void*		erealloc(void *p, uint n);
char*		estrdup(char *p);

void unmountatexit(void);

int		recvfd(int s);
int		sendfd(int s, int fd);
